;nasm 710patch.asm -o 710patch.bin

;Copy it to segment:offset CS:_int10
;or other free 64K segment


;org 0
;bits 16

;%xdefine _x86_Portable__PLATFORMBITS_ 1632
;%include "x86.asm"





align wideword_sz
_int10h:
 push ds
 push es

 ;This should be code to fix VESA modes
 ;and make them work as DOS ZSNES does:
 ;;
  ;pushf
  ;cmp ax,0x4F00
  ;jne .noi
  ;cmp ah,0x4F
  ;jne .noi
  ; mov al,0
  ; mov ah,1
  ; ;jmp $
  ; jmp .endsimple
  ;
  ;.noi:
  ;;popf


 ;Call the original INT 10h:
 ;;
  push cs   ;Set DS/ES first of all,
  push cs   ;or we won't be pointing to variables.
  pop ds
  pop es
  mov [_EAX],wideax    ;Save original AX (mode number/service, etc.)
  int 0xFF
  mov [_retEAX10H],wideax   ;Save INT 10H result in AX




 pushawide
 pushfwide
 mov eax,[_EAX]
 cmp ah,0   ;If it's not service 0 (set video mode) skip the patch for it
 jne .end
 ;Inputs:
 ;---------------
 ;BX: Value bits to select mono or color port:
 ;                   --
 ;          0000000001000000b -- color (produce 0x3DA)
 ;          0000000000100000b -- mono  (produce 0x3BA)
 ;                   --
 ;
 ;ESI == Base address of the register set
 ;;
  mov bx,0000000001000000b

  cmp al,02h
  je .set03h

  cmp al,03h
  je .set03h

  cmp al,04h
  je .set04h

  cmp al,05h
  je .set04h

  cmp al,12h
  je .set12h

  cmp al,13h
  je .set13h

  jmp .end



  ;mov esi,CGA_320x240x256_ModeX_Gen__Regs

  .set13h:
  mov esi,MCGA_320x200x256Gen__Regs
  jmp .setregs

  .set04h:
  mov esi,CGA_320x200x4Gen__MiscOutputReg
  jmp .setregs

  .set05h:
  mov esi,CGA_320x200x4Gen__MiscOutputReg
  jmp .setregs

  .set12h:
  mov esi,VGA_640x480x16Gen__Regs
  jmp .setregs

  .set02h:
  mov esi,EGA_Text_80x25x16Gen__MiscOutputReg
  jmp .setregs

  .set03h:
  mov esi,EGA_Text_80x25x16Gen__MiscOutputReg
  jmp .setregs





  .setregs:
  call VGA_Config_All_Regs




 .end:
 popfwide
 popawide
 mov wideax,[_retEAX10H]   ;Restore original INT 10H result in AX


 .endsimple:


 pop es
 pop ds
iretwide









_retEAX10H ww 0



_FLAGS dw 0
_IP dw 0
_CS dw 0


_EAX ww 0
_EBX dd 0
_ECX dd 0
_EDX dd 0
_ESI dd 0
_EDI dd 0
_EBP dd 0




;This is a bulk set of generic code
;to set VGA registers manually.
;
;The main, most difficult part
;is in the code above, which is what
;does the trick of fixing Windows 7
;INT 10H so that it works:
;;
 %include "VGA/main.asm"


align 16
